<script setup>
    import { HttpReq } from '@/utilies/httpRequest';
    import {ref, reactive, onMounted} from 'vue'

    const props = defineProps(['codeCities', 'modalityData'])
    const emits = defineEmits(['newPickup'])


    const dialogPickup = ref(false)
    const buttonSend = ref(false)


    const formInputs = reactive({
        id: null,
        modality: 0,
        pickupDate: (new Date(Date.now() - (new Date()).getTimezoneOffset() * 60000)).toISOString().substring(0, 10),
        codeDestinationCity: 11001000,
        contactName: "Comunicaciones Safra",
        reference: "",
        observation: "",
        state: 0
    })

    onMounted(() => {
        //console.log("prop: ", props.codeCities)
    })

    function openModal() {
        dialogPickup.value = true
    }

    async function generatePickup() {
        buttonSend.value = true
        let resp = await HttpReq.postData(formInputs, 'pickup')
        if(resp.status == 200) {
            emits('newPickup', resp.data)
        } else {
            console.log("error")
        }
        buttonSend.value = false
        dialogPickup.value = false
        console.log("resp: ", resp)
    }

    defineExpose({
        openModal
    })

</script>

<template>
    <!-- eslint-disable -->
    <v-row justify="center">
        <v-dialog
        v-model="dialogPickup"
        max-width="450"
        >
            <v-card>
                <v-card-title class="text-h5">
                    Generar Recogida
                </v-card-title>
                <v-card-text>
                    <v-select
                        v-model="formInputs.modality"
                        :items="props.modalityData"
                        label="Modalidad"
                        item-text="modality"
                        item-value="value"
                        dense
                    ></v-select>
                    <div class="pb-2">
                        <label for="fecha">Fecha de recogida:</label><br>
                        <input :min="(new Date(Date.now() - (new Date()).getTimezoneOffset() * 60000)).toISOString().substring(0, 10)" type="date" id="fecha" name="fecha" v-model="formInputs.pickupDate">
                    </div>
                    <v-select
                        v-model="formInputs.codeDestinationCity"
                        :items="props.codeCities"
                        label="Ciudad de destino"
                        item-text="nameD"
                        item-value="codeD"
                        dense
                        class="mt-2"
                    ></v-select>
                    <v-text-field
                        label="Nombre Contacto"
                        v-model="formInputs.contactName"
                    ></v-text-field>
                    <v-text-field
                        label="Referencia"
                        hint="Documentacion referente al envio"
                        v-model="formInputs.reference"
                    ></v-text-field>
                    <v-text-field
                        label="Observaciones"
                        hint="Anotaciones para tener en cuenta sobre el envio"
                        v-model="formInputs.observation"
                    ></v-text-field>

                </v-card-text>
                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn
                        color="green darken-1"
                        text
                        @click="generatePickup()"
                        :disabled="buttonSend"
                    >
                        Enviar
                    </v-btn>

                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>

<style>

</style>